From a29d094f2022043e82a40278063a82905ae422ad Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Tue, 11 Aug 2020 11:32:33 +0200
Subject: [PATCH] add new font: dancing-script (#45813)

---
 README                                          |   8 ++++++++
 .../dancingscript-bold-webfont.woff             | Bin 0 -> 44888 bytes
 .../dancingscript-bold-webfont.woff2            | Bin 0 -> 35632 bytes
 .../dancingscript-regular-webfont.woff          | Bin 0 -> 44824 bytes
 .../dancingscript-regular-webfont.woff2         | Bin 0 -> 35076 bytes
 static/includes/fonts/_dancing-script.scss      |  14 ++++++++++++++
 6 files changed, 22 insertions(+)
 create mode 100644 static/fonts/DancingScript/dancingscript-bold-webfont.woff
 create mode 100644 static/fonts/DancingScript/dancingscript-bold-webfont.woff2
 create mode 100644 static/fonts/DancingScript/dancingscript-regular-webfont.woff
 create mode 100644 static/fonts/DancingScript/dancingscript-regular-webfont.woff2
 create mode 100644 static/includes/fonts/_dancing-script.scss

diff --git a/README b/README
index ca96620c..80596328 100644
--- a/README
+++ b/README
@@ -289,6 +289,14 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/josefin-sans
 
+* Dancing Script
+  # Copyright 2016 The Dancing Script Project Authors (impallari@gmail.com)
+  # with Reserved Font Name 'Dancing Script’.
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # https://github.com/impallari/DancingScript
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/DancingScript/dancingscript-bold-webfont.woff b/static/fonts/DancingScript/dancingscript-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..29572e92a821a49fc747117ad668bb6e79a82917
GIT binary patch
diff --git a/static/fonts/DancingScript/dancingscript-bold-webfont.woff2 b/static/fonts/DancingScript/dancingscript-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..efcbb76af0a2a30e6f4d7a4a4cc00ed619546eb6
GIT binary patch
diff --git a/static/fonts/DancingScript/dancingscript-regular-webfont.woff b/static/fonts/DancingScript/dancingscript-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..1053ef2668df78dd999d003c838e866857044c17
GIT binary patch
diff --git a/static/fonts/DancingScript/dancingscript-regular-webfont.woff2 b/static/fonts/DancingScript/dancingscript-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..660894c9b05b1940980238baed05515f868ab302
GIT binary patch
diff --git a/static/includes/fonts/_dancing-script.scss b/static/includes/fonts/_dancing-script.scss
new file mode 100644
index 00000000..11648969
--- /dev/null
+++ b/static/includes/fonts/_dancing-script.scss
@@ -0,0 +1,14 @@
+$dancingScript-font-path: '/static/fonts/DancingScript' !default;
+
+@mixin dancingScript-font($type, $weight, $style) {
+    @font-face {
+        font-family: 'Dancing Script';
+        src: url('#{$dancingScript-font-path}/dancingscript-#{$type}-webfont.woff2') format('woff2'),
+             url('#{$dancingScript-font-path}/dancingscript-#{$type}-webfont.woff') format('woff');
+        font-weight: $weight;
+        font-style: $style;
+    }
+}
+
+@include dancingScript-font('regular', 400, normal);
+@include dancingScript-font('bold', 700, normal);
-- 
2.20.1